git-submodule.shon commit Merge branch 'maint' (50b68ae)
   1#!/bin/sh
   2#
   3# git-submodules.sh: add, init, update or list git submodules
   4#
   5# Copyright (c) 2007 Lars Hjemli
   6
   7dashless=$(basename "$0" | sed -e 's/-/ /')
   8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
   9   or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
  10   or: $dashless [--quiet] init [--] [<path>...]
  11   or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
  12   or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
  13   or: $dashless [--quiet] foreach [--recursive] <command>
  14   or: $dashless [--quiet] sync [--] [<path>...]"
  15OPTIONS_SPEC=
  16. git-sh-setup
  17. git-sh-i18n
  18. git-parse-remote
  19require_work_tree
  20
  21command=
  22branch=
  23force=
  24reference=
  25cached=
  26recursive=
  27init=
  28files=
  29nofetch=
  30update=
  31prefix=
  32
  33# Resolve relative url by appending to parent's url
  34resolve_relative_url ()
  35{
  36        remote=$(get_default_remote)
  37        remoteurl=$(git config "remote.$remote.url") ||
  38                remoteurl=$(pwd) # the repository is its own authoritative upstream
  39        url="$1"
  40        remoteurl=${remoteurl%/}
  41        sep=/
  42        while test -n "$url"
  43        do
  44                case "$url" in
  45                ../*)
  46                        url="${url#../}"
  47                        case "$remoteurl" in
  48                        */*)
  49                                remoteurl="${remoteurl%/*}"
  50                                ;;
  51                        *:*)
  52                                remoteurl="${remoteurl%:*}"
  53                                sep=:
  54                                ;;
  55                        *)
  56                                die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
  57                                ;;
  58                        esac
  59                        ;;
  60                ./*)
  61                        url="${url#./}"
  62                        ;;
  63                *)
  64                        break;;
  65                esac
  66        done
  67        echo "$remoteurl$sep${url%/}"
  68}
  69
  70#
  71# Get submodule info for registered submodules
  72# $@ = path to limit submodule list
  73#
  74module_list()
  75{
  76        git ls-files --error-unmatch --stage -- "$@" |
  77        perl -e '
  78        my %unmerged = ();
  79        my ($null_sha1) = ("0" x 40);
  80        while (<STDIN>) {
  81                chomp;
  82                my ($mode, $sha1, $stage, $path) =
  83                        /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
  84                next unless $mode eq "160000";
  85                if ($stage ne "0") {
  86                        if (!$unmerged{$path}++) {
  87                                print "$mode $null_sha1 U\t$path\n";
  88                        }
  89                        next;
  90                }
  91                print "$_\n";
  92        }
  93        '
  94}
  95
  96#
  97# Map submodule path to submodule name
  98#
  99# $1 = path
 100#
 101module_name()
 102{
 103        # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
 104        re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
 105        name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
 106                sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
 107       test -z "$name" &&
 108       die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
 109       echo "$name"
 110}
 111
 112#
 113# Clone a submodule
 114#
 115# Prior to calling, cmd_update checks that a possibly existing
 116# path is not a git repository.
 117# Likewise, cmd_add checks that path does not exist at all,
 118# since it is the location of a new submodule.
 119#
 120module_clone()
 121{
 122        path=$1
 123        url=$2
 124        reference="$3"
 125        quiet=
 126        if test -n "$GIT_QUIET"
 127        then
 128                quiet=-q
 129        fi
 130
 131        if test -n "$reference"
 132        then
 133                git-clone $quiet "$reference" -n "$url" "$path"
 134        else
 135                git-clone $quiet -n "$url" "$path"
 136        fi ||
 137        die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
 138}
 139
 140#
 141# Add a new submodule to the working tree, .gitmodules and the index
 142#
 143# $@ = repo path
 144#
 145# optional branch is stored in global branch variable
 146#
 147cmd_add()
 148{
 149        # parse $args after "submodule ... add".
 150        while test $# -ne 0
 151        do
 152                case "$1" in
 153                -b | --branch)
 154                        case "$2" in '') usage ;; esac
 155                        branch=$2
 156                        shift
 157                        ;;
 158                -f | --force)
 159                        force=$1
 160                        ;;
 161                -q|--quiet)
 162                        GIT_QUIET=1
 163                        ;;
 164                --reference)
 165                        case "$2" in '') usage ;; esac
 166                        reference="--reference=$2"
 167                        shift
 168                        ;;
 169                --reference=*)
 170                        reference="$1"
 171                        shift
 172                        ;;
 173                --)
 174                        shift
 175                        break
 176                        ;;
 177                -*)
 178                        usage
 179                        ;;
 180                *)
 181                        break
 182                        ;;
 183                esac
 184                shift
 185        done
 186
 187        repo=$1
 188        path=$2
 189
 190        if test -z "$path"; then
 191                path=$(echo "$repo" |
 192                        sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 193        fi
 194
 195        if test -z "$repo" -o -z "$path"; then
 196                usage
 197        fi
 198
 199        # assure repo is absolute or relative to parent
 200        case "$repo" in
 201        ./*|../*)
 202                # dereference source url relative to parent's url
 203                realrepo=$(resolve_relative_url "$repo") || exit
 204                ;;
 205        *:*|/*)
 206                # absolute url
 207                realrepo=$repo
 208                ;;
 209        *)
 210                die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
 211        ;;
 212        esac
 213
 214        # normalize path:
 215        # multiple //; leading ./; /./; /../; trailing /
 216        path=$(printf '%s/\n' "$path" |
 217                sed -e '
 218                        s|//*|/|g
 219                        s|^\(\./\)*||
 220                        s|/\./|/|g
 221                        :start
 222                        s|\([^/]*\)/\.\./||
 223                        tstart
 224                        s|/*$||
 225                ')
 226        git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
 227        die "$(eval_gettext "'\$path' already exists in the index")"
 228
 229        if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
 230        then
 231                (
 232                        eval_gettext "The following path is ignored by one of your .gitignore files:
 233\$path
 234Use -f if you really want to add it." &&
 235                        echo
 236                ) >&2
 237                exit 1
 238        fi
 239
 240        # perhaps the path exists and is already a git repo, else clone it
 241        if test -e "$path"
 242        then
 243                if test -d "$path"/.git -o -f "$path"/.git
 244                then
 245                        eval_gettext "Adding existing repo at '\$path' to the index"; echo
 246                else
 247                        die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
 248                fi
 249
 250        else
 251
 252                module_clone "$path" "$realrepo" "$reference" || exit
 253                (
 254                        clear_local_git_env
 255                        cd "$path" &&
 256                        # ash fails to wordsplit ${branch:+-b "$branch"...}
 257                        case "$branch" in
 258                        '') git checkout -f -q ;;
 259                        ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
 260                        esac
 261                ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
 262        fi
 263        git config submodule."$path".url "$realrepo"
 264
 265        git add $force "$path" ||
 266        die "$(eval_gettext "Failed to add submodule '\$path'")"
 267
 268        git config -f .gitmodules submodule."$path".path "$path" &&
 269        git config -f .gitmodules submodule."$path".url "$repo" &&
 270        git add --force .gitmodules ||
 271        die "$(eval_gettext "Failed to register submodule '\$path'")"
 272}
 273
 274#
 275# Execute an arbitrary command sequence in each checked out
 276# submodule
 277#
 278# $@ = command to execute
 279#
 280cmd_foreach()
 281{
 282        # parse $args after "submodule ... foreach".
 283        while test $# -ne 0
 284        do
 285                case "$1" in
 286                -q|--quiet)
 287                        GIT_QUIET=1
 288                        ;;
 289                --recursive)
 290                        recursive=1
 291                        ;;
 292                -*)
 293                        usage
 294                        ;;
 295                *)
 296                        break
 297                        ;;
 298                esac
 299                shift
 300        done
 301
 302        toplevel=$(pwd)
 303
 304        # dup stdin so that it can be restored when running the external
 305        # command in the subshell (and a recursive call to this function)
 306        exec 3<&0
 307
 308        module_list |
 309        while read mode sha1 stage path
 310        do
 311                if test -e "$path"/.git
 312                then
 313                        say "$(eval_gettext "Entering '\$prefix\$path'")"
 314                        name=$(module_name "$path")
 315                        (
 316                                prefix="$prefix$path/"
 317                                clear_local_git_env
 318                                cd "$path" &&
 319                                eval "$@" &&
 320                                if test -n "$recursive"
 321                                then
 322                                        cmd_foreach "--recursive" "$@"
 323                                fi
 324                        ) <&3 3<&- ||
 325                        die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
 326                fi
 327        done
 328}
 329
 330#
 331# Register submodules in .git/config
 332#
 333# $@ = requested paths (default to all)
 334#
 335cmd_init()
 336{
 337        # parse $args after "submodule ... init".
 338        while test $# -ne 0
 339        do
 340                case "$1" in
 341                -q|--quiet)
 342                        GIT_QUIET=1
 343                        ;;
 344                --)
 345                        shift
 346                        break
 347                        ;;
 348                -*)
 349                        usage
 350                        ;;
 351                *)
 352                        break
 353                        ;;
 354                esac
 355                shift
 356        done
 357
 358        module_list "$@" |
 359        while read mode sha1 stage path
 360        do
 361                # Skip already registered paths
 362                name=$(module_name "$path") || exit
 363                if test -z "$(git config "submodule.$name.url")"
 364                then
 365                        url=$(git config -f .gitmodules submodule."$name".url)
 366                        test -z "$url" &&
 367                        die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
 368
 369                        # Possibly a url relative to parent
 370                        case "$url" in
 371                        ./*|../*)
 372                                url=$(resolve_relative_url "$url") || exit
 373                                ;;
 374                        esac
 375                        git config submodule."$name".url "$url" ||
 376                        die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
 377                fi
 378
 379                # Copy "update" setting when it is not set yet
 380                upd="$(git config -f .gitmodules submodule."$name".update)"
 381                test -z "$upd" ||
 382                test -n "$(git config submodule."$name".update)" ||
 383                git config submodule."$name".update "$upd" ||
 384                die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
 385
 386                say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
 387        done
 388}
 389
 390#
 391# Update each submodule path to correct revision, using clone and checkout as needed
 392#
 393# $@ = requested paths (default to all)
 394#
 395cmd_update()
 396{
 397        # parse $args after "submodule ... update".
 398        orig_flags=
 399        while test $# -ne 0
 400        do
 401                case "$1" in
 402                -q|--quiet)
 403                        GIT_QUIET=1
 404                        ;;
 405                -i|--init)
 406                        init=1
 407                        ;;
 408                -N|--no-fetch)
 409                        nofetch=1
 410                        ;;
 411                -f|--force)
 412                        force=$1
 413                        ;;
 414                -r|--rebase)
 415                        update="rebase"
 416                        ;;
 417                --reference)
 418                        case "$2" in '') usage ;; esac
 419                        reference="--reference=$2"
 420                        orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 421                        shift
 422                        ;;
 423                --reference=*)
 424                        reference="$1"
 425                        ;;
 426                -m|--merge)
 427                        update="merge"
 428                        ;;
 429                --recursive)
 430                        recursive=1
 431                        ;;
 432                --)
 433                        shift
 434                        break
 435                        ;;
 436                -*)
 437                        usage
 438                        ;;
 439                *)
 440                        break
 441                        ;;
 442                esac
 443                orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 444                shift
 445        done
 446
 447        if test -n "$init"
 448        then
 449                cmd_init "--" "$@" || return
 450        fi
 451
 452        cloned_modules=
 453        module_list "$@" | {
 454        err=
 455        while read mode sha1 stage path
 456        do
 457                if test "$stage" = U
 458                then
 459                        echo >&2 "Skipping unmerged submodule $path"
 460                        continue
 461                fi
 462                name=$(module_name "$path") || exit
 463                url=$(git config submodule."$name".url)
 464                update_module=$(git config submodule."$name".update)
 465                if test -z "$url"
 466                then
 467                        # Only mention uninitialized submodules when its
 468                        # path have been specified
 469                        test "$#" != "0" &&
 470                        say "$(eval_gettext "Submodule path '\$path' not initialized
 471Maybe you want to use 'update --init'?")"
 472                        continue
 473                fi
 474
 475                if ! test -d "$path"/.git -o -f "$path"/.git
 476                then
 477                        module_clone "$path" "$url" "$reference"|| exit
 478                        cloned_modules="$cloned_modules;$name"
 479                        subsha1=
 480                else
 481                        subsha1=$(clear_local_git_env; cd "$path" &&
 482                                git rev-parse --verify HEAD) ||
 483                        die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
 484                fi
 485
 486                if ! test -z "$update"
 487                then
 488                        update_module=$update
 489                fi
 490
 491                if test "$subsha1" != "$sha1"
 492                then
 493                        subforce=$force
 494                        # If we don't already have a -f flag and the submodule has never been checked out
 495                        if test -z "$subsha1" -a -z "$force"
 496                        then
 497                                subforce="-f"
 498                        fi
 499
 500                        if test -z "$nofetch"
 501                        then
 502                                # Run fetch only if $sha1 isn't present or it
 503                                # is not reachable from a ref.
 504                                (clear_local_git_env; cd "$path" &&
 505                                        ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
 506                                         test -z "$rev") || git-fetch)) ||
 507                                die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
 508                        fi
 509
 510                        # Is this something we just cloned?
 511                        case ";$cloned_modules;" in
 512                        *";$name;"*)
 513                                # then there is no local change to integrate
 514                                update_module= ;;
 515                        esac
 516
 517                        must_die_on_failure=
 518                        case "$update_module" in
 519                        rebase)
 520                                command="git rebase"
 521                                die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
 522                                say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
 523                                must_die_on_failure=yes
 524                                ;;
 525                        merge)
 526                                command="git merge"
 527                                die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
 528                                say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
 529                                must_die_on_failure=yes
 530                                ;;
 531                        *)
 532                                command="git checkout $subforce -q"
 533                                die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
 534                                say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
 535                                ;;
 536                        esac
 537
 538                        if (clear_local_git_env; cd "$path" && $command "$sha1")
 539                        then
 540                                say "$say_msg"
 541                        elif test -n "$must_die_on_failure"
 542                        then
 543                                die_with_status 2 "$die_msg"
 544                        else
 545                                err="${err};$die_msg"
 546                                continue
 547                        fi
 548                fi
 549
 550                if test -n "$recursive"
 551                then
 552                        (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
 553                        res=$?
 554                        if test $res -gt 0
 555                        then
 556                                die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
 557                                if test $res -eq 1
 558                                then
 559                                        err="${err};$die_msg"
 560                                        continue
 561                                else
 562                                        die_with_status $res "$die_msg"
 563                                fi
 564                        fi
 565                fi
 566        done
 567
 568        if test -n "$err"
 569        then
 570                OIFS=$IFS
 571                IFS=';'
 572                for e in $err
 573                do
 574                        if test -n "$e"
 575                        then
 576                                echo >&2 "$e"
 577                        fi
 578                done
 579                IFS=$OIFS
 580                exit 1
 581        fi
 582        }
 583}
 584
 585set_name_rev () {
 586        revname=$( (
 587                clear_local_git_env
 588                cd "$1" && {
 589                        git describe "$2" 2>/dev/null ||
 590                        git describe --tags "$2" 2>/dev/null ||
 591                        git describe --contains "$2" 2>/dev/null ||
 592                        git describe --all --always "$2"
 593                }
 594        ) )
 595        test -z "$revname" || revname=" ($revname)"
 596}
 597#
 598# Show commit summary for submodules in index or working tree
 599#
 600# If '--cached' is given, show summary between index and given commit,
 601# or between working tree and given commit
 602#
 603# $@ = [commit (default 'HEAD'),] requested paths (default all)
 604#
 605cmd_summary() {
 606        summary_limit=-1
 607        for_status=
 608        diff_cmd=diff-index
 609
 610        # parse $args after "submodule ... summary".
 611        while test $# -ne 0
 612        do
 613                case "$1" in
 614                --cached)
 615                        cached="$1"
 616                        ;;
 617                --files)
 618                        files="$1"
 619                        ;;
 620                --for-status)
 621                        for_status="$1"
 622                        ;;
 623                -n|--summary-limit)
 624                        if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
 625                        then
 626                                :
 627                        else
 628                                usage
 629                        fi
 630                        shift
 631                        ;;
 632                --)
 633                        shift
 634                        break
 635                        ;;
 636                -*)
 637                        usage
 638                        ;;
 639                *)
 640                        break
 641                        ;;
 642                esac
 643                shift
 644        done
 645
 646        test $summary_limit = 0 && return
 647
 648        if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
 649        then
 650                head=$rev
 651                test $# = 0 || shift
 652        elif test -z "$1" -o "$1" = "HEAD"
 653        then
 654                # before the first commit: compare with an empty tree
 655                head=$(git hash-object -w -t tree --stdin </dev/null)
 656                test -z "$1" || shift
 657        else
 658                head="HEAD"
 659        fi
 660
 661        if [ -n "$files" ]
 662        then
 663                test -n "$cached" &&
 664                die "$(gettext -- "--cached cannot be used with --files")"
 665                diff_cmd=diff-files
 666                head=
 667        fi
 668
 669        cd_to_toplevel
 670        # Get modified modules cared by user
 671        modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
 672                sane_egrep '^:([0-7]* )?160000' |
 673                while read mod_src mod_dst sha1_src sha1_dst status name
 674                do
 675                        # Always show modules deleted or type-changed (blob<->module)
 676                        test $status = D -o $status = T && echo "$name" && continue
 677                        # Also show added or modified modules which are checked out
 678                        GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
 679                        echo "$name"
 680                done
 681        )
 682
 683        test -z "$modules" && return
 684
 685        git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
 686        sane_egrep '^:([0-7]* )?160000' |
 687        cut -c2- |
 688        while read mod_src mod_dst sha1_src sha1_dst status name
 689        do
 690                if test -z "$cached" &&
 691                        test $sha1_dst = 0000000000000000000000000000000000000000
 692                then
 693                        case "$mod_dst" in
 694                        160000)
 695                                sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
 696                                ;;
 697                        100644 | 100755 | 120000)
 698                                sha1_dst=$(git hash-object $name)
 699                                ;;
 700                        000000)
 701                                ;; # removed
 702                        *)
 703                                # unexpected type
 704                                (
 705                                        eval_gettext "unexpected mode \$mod_dst" &&
 706                                        echo
 707                                ) >&2
 708                                continue ;;
 709                        esac
 710                fi
 711                missing_src=
 712                missing_dst=
 713
 714                test $mod_src = 160000 &&
 715                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
 716                missing_src=t
 717
 718                test $mod_dst = 160000 &&
 719                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
 720                missing_dst=t
 721
 722                total_commits=
 723                case "$missing_src,$missing_dst" in
 724                t,)
 725                        errmsg="$(eval_gettext "  Warn: \$name doesn't contain commit \$sha1_src")"
 726                        ;;
 727                ,t)
 728                        errmsg="$(eval_gettext "  Warn: \$name doesn't contain commit \$sha1_dst")"
 729                        ;;
 730                t,t)
 731                        errmsg="$(eval_gettext "  Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
 732                        ;;
 733                *)
 734                        errmsg=
 735                        total_commits=$(
 736                        if test $mod_src = 160000 -a $mod_dst = 160000
 737                        then
 738                                range="$sha1_src...$sha1_dst"
 739                        elif test $mod_src = 160000
 740                        then
 741                                range=$sha1_src
 742                        else
 743                                range=$sha1_dst
 744                        fi
 745                        GIT_DIR="$name/.git" \
 746                        git rev-list --first-parent $range -- | wc -l
 747                        )
 748                        total_commits=" ($(($total_commits + 0)))"
 749                        ;;
 750                esac
 751
 752                sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
 753                sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
 754                if test $status = T
 755                then
 756                        blob="$(gettext "blob")"
 757                        submodule="$(gettext "submodule")"
 758                        if test $mod_dst = 160000
 759                        then
 760                                echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
 761                        else
 762                                echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
 763                        fi
 764                else
 765                        echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
 766                fi
 767                if test -n "$errmsg"
 768                then
 769                        # Don't give error msg for modification whose dst is not submodule
 770                        # i.e. deleted or changed to blob
 771                        test $mod_dst = 160000 && echo "$errmsg"
 772                else
 773                        if test $mod_src = 160000 -a $mod_dst = 160000
 774                        then
 775                                limit=
 776                                test $summary_limit -gt 0 && limit="-$summary_limit"
 777                                GIT_DIR="$name/.git" \
 778                                git log $limit --pretty='format:  %m %s' \
 779                                --first-parent $sha1_src...$sha1_dst
 780                        elif test $mod_dst = 160000
 781                        then
 782                                GIT_DIR="$name/.git" \
 783                                git log --pretty='format:  > %s' -1 $sha1_dst
 784                        else
 785                                GIT_DIR="$name/.git" \
 786                                git log --pretty='format:  < %s' -1 $sha1_src
 787                        fi
 788                        echo
 789                fi
 790                echo
 791        done |
 792        if test -n "$for_status"; then
 793                if [ -n "$files" ]; then
 794                        gettext "# Submodules changed but not updated:"; echo
 795                else
 796                        gettext "# Submodule changes to be committed:"; echo
 797                fi
 798                echo "#"
 799                sed -e 's|^|# |' -e 's|^# $|#|'
 800        else
 801                cat
 802        fi
 803}
 804#
 805# List all submodules, prefixed with:
 806#  - submodule not initialized
 807#  + different revision checked out
 808#
 809# If --cached was specified the revision in the index will be printed
 810# instead of the currently checked out revision.
 811#
 812# $@ = requested paths (default to all)
 813#
 814cmd_status()
 815{
 816        # parse $args after "submodule ... status".
 817        orig_flags=
 818        while test $# -ne 0
 819        do
 820                case "$1" in
 821                -q|--quiet)
 822                        GIT_QUIET=1
 823                        ;;
 824                --cached)
 825                        cached=1
 826                        ;;
 827                --recursive)
 828                        recursive=1
 829                        ;;
 830                --)
 831                        shift
 832                        break
 833                        ;;
 834                -*)
 835                        usage
 836                        ;;
 837                *)
 838                        break
 839                        ;;
 840                esac
 841                orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 842                shift
 843        done
 844
 845        module_list "$@" |
 846        while read mode sha1 stage path
 847        do
 848                name=$(module_name "$path") || exit
 849                url=$(git config submodule."$name".url)
 850                displaypath="$prefix$path"
 851                if test "$stage" = U
 852                then
 853                        say "U$sha1 $displaypath"
 854                        continue
 855                fi
 856                if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
 857                then
 858                        say "-$sha1 $displaypath"
 859                        continue;
 860                fi
 861                set_name_rev "$path" "$sha1"
 862                if git diff-files --ignore-submodules=dirty --quiet -- "$path"
 863                then
 864                        say " $sha1 $displaypath$revname"
 865                else
 866                        if test -z "$cached"
 867                        then
 868                                sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
 869                                set_name_rev "$path" "$sha1"
 870                        fi
 871                        say "+$sha1 $displaypath$revname"
 872                fi
 873
 874                if test -n "$recursive"
 875                then
 876                        (
 877                                prefix="$displaypath/"
 878                                clear_local_git_env
 879                                cd "$path" &&
 880                                eval cmd_status "$orig_args"
 881                        ) ||
 882                        die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
 883                fi
 884        done
 885}
 886#
 887# Sync remote urls for submodules
 888# This makes the value for remote.$remote.url match the value
 889# specified in .gitmodules.
 890#
 891cmd_sync()
 892{
 893        while test $# -ne 0
 894        do
 895                case "$1" in
 896                -q|--quiet)
 897                        GIT_QUIET=1
 898                        shift
 899                        ;;
 900                --)
 901                        shift
 902                        break
 903                        ;;
 904                -*)
 905                        usage
 906                        ;;
 907                *)
 908                        break
 909                        ;;
 910                esac
 911        done
 912        cd_to_toplevel
 913        module_list "$@" |
 914        while read mode sha1 stage path
 915        do
 916                name=$(module_name "$path")
 917                url=$(git config -f .gitmodules --get submodule."$name".url)
 918
 919                # Possibly a url relative to parent
 920                case "$url" in
 921                ./*|../*)
 922                        url=$(resolve_relative_url "$url") || exit
 923                        ;;
 924                esac
 925
 926                if git config "submodule.$name.url" >/dev/null 2>/dev/null
 927                then
 928                        say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
 929                        git config submodule."$name".url "$url"
 930
 931                        if test -e "$path"/.git
 932                        then
 933                        (
 934                                clear_local_git_env
 935                                cd "$path"
 936                                remote=$(get_default_remote)
 937                                git config remote."$remote".url "$url"
 938                        )
 939                        fi
 940                fi
 941        done
 942}
 943
 944# This loop parses the command line arguments to find the
 945# subcommand name to dispatch.  Parsing of the subcommand specific
 946# options are primarily done by the subcommand implementations.
 947# Subcommand specific options such as --branch and --cached are
 948# parsed here as well, for backward compatibility.
 949
 950while test $# != 0 && test -z "$command"
 951do
 952        case "$1" in
 953        add | foreach | init | update | status | summary | sync)
 954                command=$1
 955                ;;
 956        -q|--quiet)
 957                GIT_QUIET=1
 958                ;;
 959        -b|--branch)
 960                case "$2" in
 961                '')
 962                        usage
 963                        ;;
 964                esac
 965                branch="$2"; shift
 966                ;;
 967        --cached)
 968                cached="$1"
 969                ;;
 970        --)
 971                break
 972                ;;
 973        -*)
 974                usage
 975                ;;
 976        *)
 977                break
 978                ;;
 979        esac
 980        shift
 981done
 982
 983# No command word defaults to "status"
 984test -n "$command" || command=status
 985
 986# "-b branch" is accepted only by "add"
 987if test -n "$branch" && test "$command" != add
 988then
 989        usage
 990fi
 991
 992# "--cached" is accepted only by "status" and "summary"
 993if test -n "$cached" && test "$command" != status -a "$command" != summary
 994then
 995        usage
 996fi
 997
 998"cmd_$command" "$@"